# Configure paths for liborphy
# stolen from Sam Lantinga
# stolen from Manish Singh
# stolen back from Frank Belew
# stolen from Manish Singh
# Shamelessly stolen from Owen Taylor

dnl AM_PATH_ORPHY([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl Test for liborphy, and define ORPHY_CFLAGS and ORPHY_LIBS
dnl
AC_DEFUN(AM_PATH_ORPHY,
[dnl 
dnl Get the cflags and libraries from the orphy-config script
dnl
AC_ARG_WITH(orphy-prefix,[  --with-orphy-prefix=PFX   Prefix where liborphy is installed (optional)],
            orphy_prefix="$withval", orphy_prefix="")
AC_ARG_WITH(orphy-exec-prefix,[  --with-orphy-exec-prefix=PFX Exec prefix where liborphy is installed (optional)],
            orphy_exec_prefix="$withval", orphy_exec_prefix="")
AC_ARG_ENABLE(orphytest, [  --disable-orphytest       Do not try to compile and run a test liborphy program],
		    , enable_orphytest=yes)

  if test x$orphy_exec_prefix != x ; then
     orphy_args="$orphy_args --exec-prefix=$orphy_exec_prefix"
     if test x${ORPHY_CONFIG+set} != xset ; then
        ORPHY_CONFIG=$orphy_exec_prefix/bin/orphy-config
     fi
  fi
  if test x$orphy_prefix != x ; then
     orphy_args="$orphy_args --prefix=$orphy_prefix"
     if test x${ORPHY_CONFIG+set} != xset ; then
        ORPHY_CONFIG=$orphy_prefix/bin/orphy-config
     fi
  fi

  AC_REQUIRE([AC_CANONICAL_TARGET])
  AC_PATH_PROG(ORPHY_CONFIG, orphy-config, no)
  min_orphy_version=ifelse([$1], ,0.1.0,$1)
  AC_MSG_CHECKING(for liborphy - version >= $min_orphy_version)
  no_orphy=""
  if test "$ORPHY_CONFIG" = "no" ; then
    no_orphy=yes
  else
    ORPHY_CFLAGS=`$ORPHY_CONFIG $orphyconf_args --cflags`
    ORPHY_LIBS=`$ORPHY_CONFIG $orphyconf_args --libs`

    orphy_major_version=`$ORPHY_CONFIG $orphy_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    orphy_minor_version=`$ORPHY_CONFIG $orphy_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    orphy_micro_version=`$ORPHY_CONFIG $orphy_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    
    if test "x$enable_orphytest" = "xyes" ; then
    
		ac_save_CFLAGS="$CFLAGS"
      ac_save_LIBS="$LIBS"
      CFLAGS="$CFLAGS $ORPHY_CFLAGS"
      LIBS="$LIBS $ORPHY_LIBS"

dnl
dnl Now check if the installed ORPHY is sufficiently new. (Also sanity
dnl checks the results of orphy-config to some extent
dnl
      rm -f conf.orphytest
      AC_TRY_RUN([
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "orphy.h"

char*
my_strdup (char *str)
{
  char *new_str;
  
  if (str)
    {
      new_str = (char *)malloc ((strlen (str) + 1) * sizeof(char));
      strcpy (new_str, str);
    }
  else
    new_str = NULL;
  
  return new_str;
}

int main (int argc, char *argv[])
{
  int major, minor, micro;
  char *tmp_version;

  /* This hangs on some systems (?)
  system ("touch conf.orphytest");
  */
  { FILE *fp = fopen("conf.orphytest", "a"); if ( fp ) fclose(fp); }

  /* HP/UX 9 (%@#!) writes to sscanf strings */
  tmp_version = my_strdup("$min_orphy_version");
  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3) {
     printf("%s, bad version string\n", "$min_orphy_version");
     exit(1);
   }

   if (($orphy_major_version > major) ||
      (($orphy_major_version == major) && ($orphy_minor_version > minor)) ||
      (($orphy_major_version == major) && ($orphy_minor_version == minor) && ($orphy_micro_version >= micro)))
    {
      return 0;
    }
  else
    {
      printf("\n*** 'orphy-config --version' returned %d.%d.%d, but the minimum version\n", $orphy_major_version, $orphy_minor_version, $orphy_micro_version);
      printf("*** of ORPHY required is %d.%d.%d. If orphy-config is correct, then it is\n", major, minor, micro);
      printf("*** best to upgrade to the required version.\n");
      printf("*** If orphy-config was wrong, set the environment variable ORPHY_CONFIG\n");
      printf("*** to point to the correct copy of orphy-config, and remove the file\n");
      printf("*** config.cache before re-running configure\n");
      return 1;
    }
}

],, no_orphy=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi
  if test "x$no_orphy" = x ; then
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$ORPHY_CONFIG" = "no" ; then
       echo "*** The orphy-config script installed by ORPHY could not be found"
       echo "*** If ORPHY was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the ORPHY_CONFIG environment variable to the"
       echo "*** full path to orphy-config."
     else
       if test -f conf.orphytest ; then
        :
       else
          echo "*** Could not run ORPHY test program, checking why..."
          CFLAGS="$CFLAGS $ORPHY_CFLAGS"
          LIBS="$LIBS $ORPHY_LIBS"
          AC_TRY_LINK([
#include <stdio.h>
#include "orphy.h"

int main(int argc, char *argv[])
{ return 0; }
#undef  main
#define main K_and_R_C_main
],      [ return 0; ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding ORPHY or finding the wrong"
          echo "*** version of ORPHY. If it is not finding ORPHY, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system"
	  echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH"],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means ORPHY was incorrectly installed"
          echo "*** or that you have moved ORPHY since it was installed. In the latter case, you"
          echo "*** may want to edit the orphy-config script: $ORPHY_CONFIG" ])
          CFLAGS="$ac_save_CFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi
     ORPHY_CFLAGS=""
     ORPHY_LIBS=""
     ifelse([$3], , :, [$3])
  fi
  AC_SUBST(ORPHY_CFLAGS)
  AC_SUBST(ORPHY_LIBS)
  rm -f conf.orphytest
])
