/*  Orphy GTS acquisition library (liborphy)
 *  Copyright (c) Clment 'phneutre' Bourdarias
 *                   email: phneutre@users.sourceforge.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "orphy.h"

char OGTS_Enabled = 0;

/*
==================
OGTS_VerifyParam
==================
*/

int OGTS_VerifyParam(char what)
{
  if (what==OGTS_VERBOSE || what==OGTS_LOGGING)
    return 1;

  else return 0;

}

/*
==================
OGTS_Enable
==================
*/
void OGTS_Enable(char param)
{
  if (OGTS_VerifyParam(param))
    OGTS_Enabled |= param;
}

/*
==================
OGTS_Disable
==================
*/
void OGTS_Disable(char param)
{
  if (OGTS_VerifyParam(param))
    OGTS_Enabled &= (255-param);
}

/*
==================
OGTS_IsEnabled
==================
*/
int OGTS_IsEnabled(char param)
{
  if (OGTS_VerifyParam(param)) {
    if (OGTS_Enabled & param) 
      return 1;
    else return 0;
  }

  else return 0;
}
